;13.2.2007

;Win32 programs run in protected mode, flat memory model, separate 4gb virtual space
;U must ALWAYS restore  esi, edi, ebp and ebx 
; WinF will preserve segment regs, edi, esi, ebp, ebx
;ecx and edx are destroyed
;eax has F. result

;ANSI (ascii) 1byte for letter, UNICODE 2byte for letter
;@@:
 ;jmp @B ;jump back or to upper @@:
 ;jmp @F ;jump forward of to down @@:
;@@:



.386  ;.486 .586 .686 p=if U use privileged instructions
.MODEL Flat, STDCALL
      ;win32 use only flat mem model
      ;C = pass right to left (right byte is first pushed on to stack) caller balances stack!!! add sp,12
      ;PASCAL = pass parameter from left to right (left is first pushed) callee balance stack!!!
      ;STDCALL = right to left push to stack callee balance stack
option casemap:none ;labels are case-sensitive


   include \masm32\include\windows.inc ;this first
   include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
;Kernel32.dll contains API functions that deal with memory and process management

   include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib
;User32.dll controls the user interface aspects

   include \masm32\include\gdi32.inc
includelib \masm32\lib\gdi32.lib
;Gdi32.dll is responsible for graphics operations




;WinMain proto :DWORD,:DWORD,:DWORD,:DWORD  ;win32 funkcija
;there's legend that U can make prg without winmain f.
;The Legend is TRUE :)
WndProc            PROTO :DWORD,:DWORD,:DWORD,:DWORD ;
WndProcInput   PROTO :DWORD,:DWORD,:DWORD,:DWORD  ;separate Win Procedures for input window
WndProcFlag    PROTO :DWORD,:DWORD,:DWORD,:DWORD ;separate win procedure for flag window

;INVOKE ADDR var == lea eax, var ; push eat ALWAYS!
;INVOKE OFFSET var can be dynamic and static
;(dynamic) LOCAL var ; OFFSET var == lea eax ,var ;push eax
;(static) .DATA/.DATA?/.CODE/.CONST var dd ; OFFSET var ; push [0430245]
;(static) offset F works because F is allocated at compile time


.DATA
wc dd sizeof WNDCLASSEX
   dd CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW or CS_DBLCLKS
   dd offset WndProc, 0, 0, 0, 0, 0
   dd COLOR_WINDOW +1, 0
   dd offset  ClassName, 0

wcFlag WNDCLASSEX { sizeof WNDCLASSEX, \
  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW or CS_DBLCLKS, 
  offset WndProc, 0, 0,0, 0, 0, 
  COLOR_WINDOW, 0, offset  ClassName, 0 }

;wc WNDCLASSEX <>
; WNDCLASSEX STRUCT
;  cbSize            DWORD      ?
;  style             DWORD      ?
;  lpfnWndProc       DWORD      ?
;  cbClsExtra        DWORD      ?
;  cbWndExtra        DWORD      ?
;  hInstance         DWORD      ?
;  hIcon             DWORD      ?
;  hCursor           DWORD      ?
;  hbrBackground     DWORD      ?
;  lpszMenuName      DWORD      ?
;  lpszClassName     DWORD      ?
;  hIconSm           DWORD      ?
; WNDCLASSEX ENDS


;later load last position from file somehow
WMainHeight  dd 300
WMainWidth   dd 300
WMainX       dd 100
WMainY       dd 100

WInputHeight1 dd  30  
WInputWidth1  dd 200
WInputX1      dd   0
WInputY1      dd   0

WFlagHeight1 dd  30
WFlagWidth1  dd  30
WFlagX1      dd 300
WFlagY1      dd  10
;nice if possible to use this file






szBin db "00000000000000000000000000000000",0
szTxt db "Weevil.",0
MouseClick db 0         ; 0=no click yet

ButtonClassName db  "button", 0
ButtonText      db  "My First Button", 0
EditClassName   db  "edit", 0
TestString      db  "Wow! I'm in an edit box now", 0
TxtFlag   db "Flag window",0



.DATA?
;to preallocate some memory 
hInstance dd ? ; Instance handle of our program
pmsg dd ?         ;points to msg:MSG
hwndMainWindow   dd ?     ;handle of MainWindow

msg MSG <?>
CommandLine      dd ?
; MSG STRUCT
;  hwnd      DWORD      ?
;  message   DWORD      ?
;  wParam    DWORD      ?
;  lParam    DWORD      ?
;  time      DWORD      ?
;  pt        POINT      <>
; MSG ENDS

hwndInputWindow1 dd ?     ;handle of InputWindow1
  hEDITInputWindow1  dd ?     ;handle of EDIT control on Input1 Windoe
hwndFlagWindow1  dd ?     ;handle of FlagWindow1
hBitmapF dd ?




char dd ?
hitpoint POINT <>
hitpointF POINT <>
cnt dd ?
buffer          db 512 dup(?)

.CONST
;const can not be changed. could be usefull
ClassName db "DicWinClass",0  ;name of our window class. what's window class?
AppName db "Dictionary 0.0",0 ;string on 
;ClassFlagName db "FlagClass",0
;AppFlagName db "Flag",0

ButtonID        equ 1
EditID          equ 2

;menu
;IDM_HELLO       equ 1
;IDM_CLEAR       equ 2
;IDM_GETTEXT     equ 3
;IDM_EXIT        equ 4


.CODE
   Dictionary_:

;_______________________________
;to calculate position of window
;        push SM_CXSCREEN
;        call GetSystemMetrics
;sub eax,W1width
;mov W1topX,eax        
  ;      push SM_CYSCREEN
  ;      call GetSystemMetrics

;______________
;to lea msg MSG
lea eax,msg
mov pmsg,eax


  push 0             ;0=returns a handle of the file used to create the calling process
call GetModuleHandle ;Under Win32, hmodule = hinstance = ID of prg = linear address of your program in memory.
 mov hInstance,eax
mov wc.WNDCLASSEX.hInstance, eax

call GetCommandLine ;get the command line. don't call it IF prg doesn't process the commandline.
mov CommandLine,eax
;cmp len CommandLone,128
;jnge L1
;mov CommandLine,0
;L1:  somehow


    push 500 ;IDI_WARNING ;IDI_EXCLAMATION ;IDI_APPLICATION
    push hInstance ;0 for standard icons!!!
call LoadIcon
 mov wc.WNDCLASSEX.hIcon,eax      ;handle of icon for your prg
 mov wc.WNDCLASSEX.hIconSm,eax    ;handle to small icon (same?)

  push IDC_IBEAM ;txt cursor like
  push 0 ;hInstance  or 0 for windef cursor
call LoadCursor
 mov wc.WNDCLASSEX.hCursor,eax   

lea eax,wc ;address of wc structure
  push eax
call RegisterClassEx   ;register wcInputClass window class



;Create Main Window
;***************
   push 0  ;pointer to data struct passed to win ?
   push hInstance  ;=
   push 0   ;manu handle
   push 0 ; ;hWnd of Parent/owner window if U are creating child window ;0=no child or First window
   push WMainHeight ;200 ;CW_USEDEFAULT  ; window HEIGHT !
   push WMainWidth ;100 ;CW_USEDEFAULT    ; window WIDTH !
   push WMainY ;CW_USEDEFAULT  ;y  top left point
   push WMainX ;CW_USEDEFAULT  ;x  top left point
   push WS_VISIBLE or WS_SIZEBOX ;;WS_EX_ABSPOSITION for stationary win ;window LOOKS important! ; or WS_BORDER or WS_POPUP
   push offset AppName  ;0=empty
   push offset ClassName ;lpClassName  address of  win class ?
   push WS_EX_TOPMOST ; or WS_EX_TOOLWINDOW	;for no tab no taskbar handle
call CreateWindowEx
 mov hwndMainWindow,eax ;handle of Main Window!
;this is unique win handle

  ;         push 600
  ;         push hInstance
  ;      call LoadMenu
  ;        push eax
  ;        push hWnd
  ;      call SetMenu

            push SW_SHOWNORMAL ; =SW_SHOWDEFAUL ; SW_HIDE ;
            push hwndMainWindow
          call ShowWindow ;display our window on desktop

            push hwndMainWindow
          call UpdateWindow ;refresh the client area
;*** Create Main Window **********




;*** Create Input1 Window *********
  push 0  ;pointer to data struct passed to win ?
  push hInstance 
  push 0            ;manu handle
  push hwndMainWindow     ;hWnd of owner window; 0=no child
  push WInputHeight1 ;200 ;CW_USEDEFAULT ; window HEIGHT
  push WInputWidth1  ;200 ;CW_USEDEFAULT ; window WIDTH
  push WInputY1      ;10 ;CW_USEDEFAULT  ;y top left point
  push WInputX1      ;10 ;CW_USEDEFAULT  ;x top left point
  push WS_VISIBLE or WS_BORDER or WS_POPUP or WS_SIZEBOX ;;WS_EX_ABSPOSITION for stationary win ;window LOOKS important!
  push offset AppName  ;0=empty
  push offset ClassName ;lpClassName  address of  win class ?
  push WS_EX_TOPMOST or WS_EX_TOOLWINDOW	;for no tab no taskbar handle
call CreateWindowEx
 mov hwndInputWindow1,eax ;handle of win?

        push SW_SHOWNORMAL
        push hwndInputWindow1
      call ShowWindow ;display our window on desktop
        push hwndInputWindow1
      call UpdateWindow ;refresh the client area

;***** Create Flag1 Window **********
  push 0            ;pointer to data struct passed to win ?
  push hInstance    ;hInstance of Prg
  push 0            ;manu handle
  push hwndMainWindow     ;hWnd of parent/owner window; 0=no child
  push WFlagHeight1 ;CW_USEDEFAULT  ; window HEIGHT
  push WFlagWidth1  ;CW_USEDEFAULT  ; window WIDTH
  push WFlagY1      ;CW_USEDEFAULT  ;y top left point
  push WFlagX1      ;CW_USEDEFAULT  ;x top left point
  push WS_VISIBLE or WS_BORDER or WS_POPUP or WS_SIZEBOX ;;WS_EX_ABSPOSITION for stationary win ;window LOOKS important!
  push offset AppName  ;0=empty
  push offset ClassName ;lpClassName  address of  win class ?
  push WS_EX_TOPMOST or WS_EX_TOOLWINDOW	;for no tab no taskbar handle
call CreateWindowEx
mov hwndFlagWindow1,eax ;handle of win

            push SW_SHOWNORMAL ; =SW_SHOWDEFAUL
            push hwndFlagWindow1
          call ShowWindow ;display our window on desktop

            push hwndFlagWindow1
          call UpdateWindow ;refresh the client area
;****** Create Flag1 Window ***********




;_________________________________________________________
DictionaryLoop:
;inc cnt
push 0  ;wMsgFilterMax highest msg value :(
push 0  ;wMsgFilterMin  lowest msg value :(
push 0  ;hwnd of window NULL=any window of thread ???
push pmsg    ;address of msg STRUCT
call GetMessage  ;put message in msg:MSG STRUCT

cmp eax,0   ;Exit prg if msg is 0
je ExitDictionary


;lea eax,msg ;necesery for Stack variable
;push eax
push pmsg
call TranslateMessage ;never modifyes msg! what if eax=0?
push pmsg
call DispatchMessage ;put msg in WinProc ?
jmp DictionaryLoop

ExitDictionary:
;mov eax,msg.wParam ;return exit code in eax
;push eax
push msg.wParam
call ExitProcess ;quit our program. The exit code is returned in eax from WinMain. But if U have no winmain  push msg.wParam is perfect :D
;______________________________________________________________

;*******************
;*******************
;*******************
;@@:
 ;jmp @B ;jump back or to upper @@:
 ;jmp @F ;jump forward or to down @@:
;@@:
;______________________________________________________________
WndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
LOCAL hdcF:HDC
LOCAL psF:PAINTSTRUCT
   LOCAL hMemDCF:HDC
   LOCAL rectF:RECT



  ;push eax ;do I have to preserve EAX?
mov eax,hWnd
cmp hwndInputWindow1,eax
 je Input1
cmp hwndFlagWindow1,eax
je Flag1 
cmp hwndMainWindow,eax
  je MainWindow
  
;*************** Input1 Window Proc ******************
Input1:




@@:
cmp uMsg,WM_CREATE
jne @F

 invoke LoadBitmap,hInstance,100
      mov hBitmapF,eax

            push 0
            push hInstance
            push EditID
            push hwndInputWindow1 ;hWnd makes Edit on all 3 windows
            push WInputHeight1  ;25  ;edit hight
            push WInputWidth1   ;200 ;edit width
            push 0 ;Y of edit control
            push 0 ;X of edit control window
            push WS_CHILD or WS_VISIBLE or ES_LEFT or ES_AUTOHSCROLL or WS_BORDER 
            push 0
            push OFFSET EditClassName
            push WS_EX_LEFT	;WS_EX_STATICEDGE	;WS_EX_CLIENTEDGE
          call CreateWindowEx 
           mov  hEDITInputWindow1,eax
             push eax ;hEDITInputWindow1
           call SetFocus  ;if U vant fokus on EDIT


@@:
PreCLOSEInputWindow1:
   cmp uMsg, WM_CLOSE
   jne DestroyPrg

jmp @F
Cloc db "Exit InputWindow1",0
Clot db "Do you want to exit Input Window1 ?",0
@@:;

  push MB_YESNO
  push OFFSET Cloc ; caption
  push OFFSET Clot ;txt
  push hWnd
call MessageBox
 cmp eax, IDNO  ; suppose cmp eax, IDYES je DestroyPrg works too.
   jne DestroyPrg ;or sendmessage hide Flag1 and Input1 window
   xor eax,eax
     ret
;************ End Input1 Window Proc **************
jmp DestroyPrg ;redundant destroy check or jmp last





;*********Flag Window1 Proc *****************
@@:
Flag1:

;cmp uMsg,WM_CREATE
;jne @F
;       invoke LoadBitmap,hInstance,100
;     mov hBitmapF,eax

@@:
 cmp uMsg,WM_PAINT
 jne @F
      invoke BeginPaint,hwndFlagWindow1,addr psF
      mov hdcF,eax
      invoke CreateCompatibleDC,hdcF
      mov hMemDCF,eax
      invoke SelectObject,hMemDCF,hBitmapF
      invoke GetClientRect,hwndFlagWindow1,addr rectF
      invoke BitBlt,hdcF,0,0,rectF.right,rectF.bottom,hMemDCF,0,0,SRCCOPY
      invoke DeleteDC,hMemDCF
      invoke EndPaint,hwndFlagWindow1,addr psF

cmp uMsg,WM_DESTROY
 jne @F
      invoke DeleteObject,hBitmapF
        invoke PostQuitMessage,NULL



@@:
PreCLOSEFlagWindow1:
   cmp uMsg, WM_CLOSE
   jne DestroyPrg;

jmp @F
msgFlagExitCaption db "Exit Flag Window1",0
msgFlagExit db "Do you want to exit Flag Window1?",0
@@:

push MB_YESNO
push OFFSET msgFlagExitCaption ; caption
push OFFSET msgFlagExit ;txt
push hWnd
call MessageBox
 cmp eax, IDNO  ; suppose cmp eax, IDYES je DestroyPrg works too.
 jne DestroyPrg ;or sendmessage hide Flag1 and Input1 window
  xor eax,eax
  ret
;************End Flag Window1 Proc ***************
jmp DestroyPrg  ;redundant destroy check





;________________________________________________________________
MainWindow:

;jmp @F
;mainwc db "main window",0
;maint db "main window?",0
;@@:

 ; push MB_YESNO
 ; push OFFSET mainwc ; caption
 ; push OFFSET maint  ;txt
 ; push hWnd
;call MessageBox
; cmp eax, MB_YES
; je last
; xor eax,eax
;  ret


@@:
cmp uMsg,WM_LBUTTONDOWN
jne @F
            mov eax,lParam
      	and eax,0ffffh
      	mov hitpoint.x,eax
      	mov eax,lParam
      	shr eax,16
      	mov hitpoint.y,eax
      	mov MouseClick,TRUE
      	invoke InvalidateRect,hWnd,NULL,TRUE
      invoke SetFocus, hWnd ;NOT hwnd!!!

@@:
cmp uMsg, WM_CHAR
jne @F
              push wParam
              pop char
              invoke InvalidateRect, hWnd,NULL,TRUE
              
@@:
cmp uMsg, WM_PAINT
jne @F

                  invoke BeginPaint,hWnd, ADDR ps
                  mov    hdc,eax
              invoke TextOut,hdc,210,0,ADDR char,1 ;add
                       invoke GetClientRect,hWnd, ADDR rect
                       invoke DrawText, hdc,ADDR szTxt,-1, ADDR rect, DT_SINGLELINE or DT_CENTER or DT_VCENTER
              
               cmp MouseClick, TRUE
               jne nopaint
              invoke lstrlen,ADDR AppName
              invoke TextOut,hdc,hitpoint.x,hitpoint.y,ADDR AppName,eax
              
         
        nopaint:
        invoke EndPaint,hWnd, ADDR ps


@@:
PreCLOSE:
cmp uMsg, WM_CLOSE
jne DestroyPrg

              jmp @F
              msgMainExitCaption db "Dictionaty Exit",0
              msgMainExitTxt db "Are U sure U want to exit Main Window?",0
              @@:

                    push MB_YESNO
                    push OFFSET msgMainExitCaption ; caption
                    push OFFSET msgMainExitTxt ;txt
                    push hWnd
                  call MessageBox
 cmp eax, IDNO  ; suppose cmp eax, IDYES je DestroyPrg works too.
 jne DestroyPrg
  xor eax,eax
  ret

@@:
DestroyPrg:
   cmp uMsg, WM_DESTROY
   jne last

  push 0             ;push wParam instead of NULL???   
call PostQuitMessage ; wParam of WM_QUIT message?
 xor eax,eax
ret

@@:
last:
  push lParam
  push wParam
  push uMsg
  push hWnd
call DefWindowProc ;eats all other messages :)
 ret

WndProc endp
   end Dictionary_